#pragma once
#include <vector>

using namespace std;

class MatToVec
{
private:
	int H, W;
	vector<vector<int>> M;
	vector<vector<int>> T;
	vector<int> V;
	vector<int> Y;

	int IfOdd(int k);
	void InitTemporalM();

public:
	MatToVec();
	void SetMatrix(vector<vector<int>>& mat);
	void SetVector(vector<int>& vec);
	vector<int> ReturnVector() { return V; }

	void ScanLine();
	void LeftRight();
	void ZigZag();
	void Strips(int d);
	void Hilbert();

	int DeScanLine();
	int DeLeftRight();
	int DeZigZag();
	int DeStrips(int d);
	int DeHilbert();
};

