#pragma once
#include <vector>

using namespace std;

#define GUARD -2
#define VISITED -1
#define EMPTY -3

typedef struct MyABCStruct
{
	int f;
	int v;
	int offset;
} ABCStruct;

class InverseFrequencies
{
private:
	vector<int> I; 
	vector<int> O;
	vector<ABCStruct> ABC;
	int n; 
public:
	InverseFrequencies();

	void InitOriginal(vector<int> V);
	vector<int> DoIFOriginal();
	vector<int>  DeIFOriginal(vector<ABCStruct>& Abc, vector<int>& VIF);

	void Init(vector<int> V, int SortedDown);
	vector<int> DoIF();
	vector<ABCStruct> ReturnAlphabet() { return ABC; }
	int ReturnSize() { return n; }

	vector<int>  DeIF(int n, vector<ABCStruct>& Abc, vector<int>& VIF);
};

