#pragma once
#include <vector>

using namespace std;

typedef struct ABCEl
{
	int el;
	struct ABCEl* next;

} ABCElement;


class MwI
{
private:
	int lowerBound;
	int upperBound;
	int ABCSize;
	int delta;
	int FirstEl;
	ABCElement* ABC;
	ABCElement* ABCTail;
	ABCElement* Pool;
	vector<int> O;

	void AddToPool(ABCElement*);
	ABCElement* GetFromPool();
	int CountPool();

	void InitABC();
	ABCElement* DeleteList(ABCElement* );
	int GetPosition(int v, ABCElement** qPrev, ABCElement** q);
	void MoveTToFront(ABCElement* head, ABCElement* tail, int a, int b);
	int GetValue(int position, ABCElement** qPrev, ABCElement** q);

	void PrintABC();
	void PrintABC(int );
	void PrintList(ABCElement* T);
public:
	MwI();
	~MwI();
	void Init(int k, int l, int h, int first);


	vector<int> DoMwI(vector<int> I);
	vector<int> DoDeMwI(vector<int> I);
};

